#include <iostream>
using namespace std;

int main()
{
    int e;
    int a,b,c,d;
    cin >> a >> b >> c >> d >> e;
    a=a*a*a;
    b=b*b*b;
    c=c*c*c;
    d=d*d*d;
    e=e*e*e;
    int boxes=0;
    if(a==e || b==e)
    {
        boxes=4;
    }
    else if(c==e)
    {
        if(a+b<=e)
        {
            boxes=3;
        }
        else
        {
            boxes=4;
        }
    }
    else if(d==e)
    {
        boxes++;
        if(a+b+c<=e)
        {
            boxes++;
        }
        else if(b+c<=e || a+c<=e || b+a<=e)
        {
            boxes+=2;
        }
        else
        {
            boxes+=4;
        }
    }
    else
    {
        if(a+b+c+d<=e)
        {
            boxes++;
        }
        else if(b+c+d || a+c+d || b+a+d || b+c+a)
        {
            boxes+=2;
        }
        else if(c+d<=e || b+d<=e || a+d<=e || c+b<=e || c+a<=e|| a+b<=e)
        {
            if(c+d<=e)
            {
                if(a+b<=e)
                {
                    boxes+=2;
                }
                else
                {
                    boxes+=3;
                }
            }
            else if(b+d<=e)
            {
                if(a+c<=e)
                {
                    boxes+=2;
                }
                else
                {
                    boxes+=3;
                }
            }
            else if(a+d<=e)
            {
                if(b+c<=e)
                {
                    boxes+=2;
                }
                else
                {
                    boxes+=3;
                }
            }
        }
        else
        {
            boxes+=4;
        }
    }

    cout << boxes;

    return 0;
}
